"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tableMdastBuilder = exports.componentDocTableMdastBuilder = exports.componentDocMdastBuilder = exports.mdastBuilder = void 0;
const u = require("unist-builder");
exports.mdastBuilder = (docs) => [].concat(...docs.map(vo => exports.componentDocMdastBuilder(vo)));
exports.componentDocMdastBuilder = (componentDoc) => [
    u('heading', { depth: 3 }, [u('text', componentDoc.displayName)]),
    u('text', componentDoc.description),
    u('heading', { depth: 4 }, [u('text', 'props')]),
    exports.componentDocTableMdastBuilder(componentDoc, [
        {
            title: 'prop',
            render: (vo) => u('strong', [u('text', vo.name)]),
        },
        {
            title: 'description',
            render: (vo) => vo.description,
        },
        {
            title: 'type',
            render: (vo) => vo.type.name,
        },
        {
            title: 'default',
            render: (vo) => `${vo.defaultValue && vo.defaultValue.value}`,
        },
        {
            title: 'required',
            render: (vo) => vo.required ? ':white_check_mark:' : ':negative_squared_cross_mark:',
        },
    ]),
];
exports.componentDocTableMdastBuilder = (componentDoc, columns) => exports.tableMdastBuilder([
    columns.map(vo => vo.title),
    ...Object.values(componentDoc.props).map((prop, index) => columns.map(vo => vo.render(prop, index, componentDoc)))
]);
exports.tableMdastBuilder = ([...rows], align = []) => u('table', { align }, rows.map(row => u('tableRow', row.map(vo => u('tableCell', [typeof vo === 'string' ? u('text', vo) : vo])))));
//# sourceMappingURL=mdastBuilder.js.map